import numpy as np

class Domain:
  ntx = 4
  nty = 4
  sx = 0
  ex = 0
  sy = 0
  ey = 0
  u = np.empty
  u_new = np.empty
  u_exact = np.empty
  f = np.empty
  coef = []
  it_max = 1000

  def initialization(self):
    self.u = np.zeros((self.ex-self.sx+3,self.ey-self.sy+3),
     dtype=np.float64)
    self.u_new = np.zeros((self.ex-self.sx+3,self.ey-self.sy+3),
     dtype=np.float64)
    self.u_exact = np.zeros((self.ex-self.sx+3,self.ey-self.sy+3),
     dtype=np.float64)
    self.f = np.zeros((self.ex-self.sx+3, self.ey-self.sy+3),
     dtype=np.float64)
    hx = 1/(self.ntx+1)
    hy = 1/(self.nty+1)
    self.coef = [(0.5*hx*hx*hy*hy)/(hx*hx+hy*hy), 1./(hx*hx), 1./(hy*hy)]
    for iterx in range(self.sx, self.ex + 1):  
      for itery in range(self.sy, self.ey + 1): 
        x = iterx * hx
        y = itery * hy
        self.f[iterx-(self.sx-1),itery-(self.sy-1)] = 2*(x*x - x + y*y - y)
        self.u_exact[iterx-(self.sx-1),itery-(self.sy-1)] = \
         x * y * (x - 1) * (y - 1)
  
  def computation(self):
    #print(f"Coef : {self.coef}")
    #print(f"f : {self.f}")
    for iterx in range(self.sx, self.ex+1):
      for itery in range(self.sy, self.ey+1):
        self.u_new[iterx-(self.sx-1),itery-(self.sy-1)] = \
         self.coef[0] * (self.coef[1] * (self.u[iterx+1-(self.sx-1),itery-(self.sy-1)] + \
         self.u[iterx-1-(self.sx-1),itery-(self.sy-1)]) + \
         self.coef[2] * (self.u[iterx-(self.sx-1),itery+1-(self.sy-1)] + \
         self.u[iterx-(self.sx-1),itery-1-(self.sy-1)]) - \
         self.f[iterx-(self.sx-1),itery-(self.sy-1)])
  
  def output_results(self):
    print(f"Exact Solution u_exact - Computed Solution u")
    for itery in range(self.sy,self.ey+1):
      print(f"{self.u_exact[1-(self.sx-1),itery-(self.sy-1)]} {self.u[1-(self.sx-1),itery-(self.sy-1)]}")
  